#include "../df_lua_connection.h"

int l_open( lua_State *L )
{
    // Channel-Data
    LuaChannel *lc = checkchannel( L );
    // Type
    int commType = static_cast<int>( luaL_checkinteger( L, 2 ) );
    luaL_argcheck( L, commType == 1 || commType == 3 || commType == 4, 2, "out of range" );
    // commString
    const char *commString = luaL_checkstring( L, 3 );
    // commValue
    int commValue = static_cast<int>( luaL_checkinteger( L, 4 ) );
    // commTimeout
    int commTimeout = static_cast<int>( luaL_checkinteger( L, 5 ) );

    lua_pushboolean( L, DFCComOpenIV( lc->id, 0, commType, const_cast<char *>( commString ), commValue, commTimeout ) );

    return 1;
}

int l_close( lua_State *L )
{
    // Channel-Data
    LuaChannel *lc = checkchannel( L );

    DFCComClose( lc->id );

    return 0;
}

int l_isOpen( lua_State *L )
{
    // Channel-Data
    LuaChannel *lc = checkchannel( L );

    lua_pushboolean( L, DFCIsChannelOpen( lc->id ) );

    return 1;
}

int l_write( lua_State *L )
{
    // Channel-Data
    LuaChannel *lc = checkchannel( L );
    // Zu schreibender string
    const char *buffer = luaL_checkstring( L, 2 );
    // Zustzliche Parameter.
    int toWrite = static_cast<int>( luaL_checkinteger( L, 3 ) );
    int written = 0;

    lua_pushboolean( L, DFCWrite( lc->id, const_cast<char *>( buffer ), toWrite, &written, &lc->errorNumber ) );
    lua_pushinteger( L, written );
    int res = 2;
    if ( lua_toboolean( L, -1 ) == false )
        push_errorNumber( lc, res );

    return res;
}

int l_read( lua_State *L )
{
    // Channel-Data
    LuaChannel *lc = checkchannel( L );
    // Zustzliche Parameter.
    int toRead = static_cast<int>( luaL_checkinteger( L, 2 ) );
    int read = 0;
    // Zu lesender string
    std::string buffer( toRead, '\0' );

    lua_pushboolean( L, DFCWrite( lc->id, const_cast<char *>( buffer.data() ), toRead, &read, &lc->errorNumber ) );
    lua_pushinteger( L, read );
    int res = 2;
    if ( lua_toboolean( L, -1 ) == false )
        push_errorNumber( lc, res );

    return res;
}